// TerminalDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Terminal.h"
#include "TerminalDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEBUGMODE	0

/////////////////////////////////////////////////////////////////////////////
// CTerminalDlg dialog

CTerminalDlg::CTerminalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTerminalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTerminalDlg)
	m_strToSend = _T("");
	m_strSpeed = _T("");
	m_bAddCRLF = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hPort = INVALID_HANDLE_VALUE;
	m_uTimer = 0;

	DebugLen = 0;
}

void CTerminalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTerminalDlg)
	DDX_Control(pDX, IDC_CONNECT, m_ctrlConnect);
	DDX_Control(pDX, IDC_EDIT1, m_ctrlEdit);
	DDX_Text(pDX, IDC_EDIT_SEND, m_strToSend);
	DDV_MaxChars(pDX, m_strToSend, 16);
	DDX_CBString(pDX, IDC_COMBO_SPEED, m_strSpeed);
	DDX_Check(pDX, IDC_CHECK_CRLF, m_bAddCRLF);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTerminalDlg, CDialog)
	//{{AFX_MSG_MAP(CTerminalDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_SEND, OnButtonSend)
	//}}AFX_MSG_MAP
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_SENDCHAR, OnSendChar)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTerminalDlg message handlers

BOOL CTerminalDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	OnDisconnect();
	
	m_ctrlEdit.SetParent(this);
	m_ctrlEdit.SetFocus();

	m_uTimer = SetTimer(1, 100, NULL);

	m_strSpeed = _T("19200");
	m_bAddCRLF = TRUE;
	UpdateData(FALSE);

	return FALSE;
}

void CTerminalDlg::OnDestroy() 
{
	if (m_uTimer) KillTimer(1);
	
	OnDisconnect();
	
	CDialog::OnDestroy();
}

void CTerminalDlg::OnConnect() 
{
	if (m_hPort != INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hPort);
		m_hPort = INVALID_HANDLE_VALUE;
		m_ctrlConnect.SetWindowText(_T("Connect"));

//		m_ctrlConnect.EnableWindow(TRUE);

//		m_ctrlEdit.EnableWindow(FALSE);
//		m_ctrlDisconnect.EnableWindow(FALSE);
		return;
	}


	UpdateData(); // get speed

	// Change the DCB structure settings.
	TCHAR* pc = m_strSpeed.LockBuffer();
	m_strSpeed.UnlockBuffer();
	int br = _ttoi(pc);
	if(br < 110 || br > 115200)
		br = 19200;

	// Open the serial port.
	m_hPort = CreateFile (TEXT("COM1:"),   // Pointer to the name of the port
						  GENERIC_READ | GENERIC_WRITE,
							               // Access (read-write) mode
						  0,               // Share mode
						  NULL,            // Pointer to the security attribute
						  OPEN_EXISTING,   // How to open the serial port
						  0,               // Port attributes
						  NULL);           // Handle to port with attribute
                                           // to copy
	
	if (m_hPort == INVALID_HANDLE_VALUE)
	{
		// Display the string.
		MessageBox(TEXT("Open Error"), TEXT("Terminal"), MB_OK | MB_ICONHAND);
		return;
	}

	DCB PortDCB;

	// Initialize the DCBlength member. 
	PortDCB.DCBlength = sizeof (DCB); 

	// Get the default port setting information.
	GetCommState (m_hPort, &PortDCB);

	PortDCB.BaudRate = br;             // Current baud 

	PortDCB.fBinary = TRUE;               // Binary mode; no EOF check 
	PortDCB.fParity = TRUE;               // Enable parity checking 
	PortDCB.fOutxCtsFlow = FALSE;         // No CTS output flow control 
	PortDCB.fOutxDsrFlow = FALSE;         // No DSR output flow control 
//	PortDCB.fDtrControl = DTR_CONTROL_ENABLE; 
	PortDCB.fDtrControl = DTR_CONTROL_DISABLE; 
	                                      // DTR flow control type 
	PortDCB.fDsrSensitivity = FALSE;      // DSR sensitivity 
	PortDCB.fTXContinueOnXoff = TRUE;     // XOFF continues Tx 
	PortDCB.fOutX = FALSE;                // No XON/XOFF out flow control 
	PortDCB.fInX = FALSE;                 // No XON/XOFF in flow control 
	PortDCB.fErrorChar = FALSE;           // Disable error replacement 
	PortDCB.fNull = FALSE;                // Disable null stripping 
//	PortDCB.fRtsControl = RTS_CONTROL_ENABLE; 
	PortDCB.fRtsControl = RTS_CONTROL_DISABLE; 
		                                  // RTS flow control 
	PortDCB.fAbortOnError = FALSE;        // Do not abort reads/writes on 
		                                  // error
	PortDCB.ByteSize = 8;                 // Number of bits/byte, 4-8 
	PortDCB.Parity = NOPARITY;            // 0-4=no,odd,even,mark,space 
	PortDCB.StopBits = ONESTOPBIT;        // 0,1,2 = 1, 1.5, 2 

	// Configure the port according to the specifications of the DCB 
	// structure.
	if (!SetCommState (m_hPort, &PortDCB))
	{
		// Display the string.
		CloseHandle(m_hPort);

		MessageBox(TEXT("SetCommState Error"), TEXT("Terminal"), MB_OK | MB_ICONHAND);
		return;
	}

	// Retrieve the time-out parameters for all read and write operations
	// on the port. 
	COMMTIMEOUTS CommTimeouts;
	GetCommTimeouts (m_hPort, &CommTimeouts);

	// Change the COMMTIMEOUTS structure settings.
	CommTimeouts.ReadIntervalTimeout = MAXDWORD;  
	CommTimeouts.ReadTotalTimeoutMultiplier = 0;  
	CommTimeouts.ReadTotalTimeoutConstant = 0;    
	CommTimeouts.WriteTotalTimeoutMultiplier = 100;  
	CommTimeouts.WriteTotalTimeoutConstant = 1000;    

	// Set the time-out parameters for all read and write operations
	// on the port. 
	if (!SetCommTimeouts (m_hPort, &CommTimeouts))
	{
		// Display the string.
		CloseHandle(m_hPort);

		MessageBox(TEXT("SetCommTimeouts Error"), TEXT("Terminal"), MB_OK | MB_ICONHAND);
		return;
	}
		
	// drop DTR for half of second to reset the modem
	EscapeCommFunction(m_hPort, SETDTR);
	EscapeCommFunction(m_hPort, CLRDTR);
	EscapeCommFunction(m_hPort, CLRRTS);

	DWORD dwStart = GetTickCount();
	while ((GetTickCount() - dwStart) < 500);

	EscapeCommFunction(m_hPort, SETDTR);
	EscapeCommFunction(m_hPort, SETRTS);

	dwStart = GetTickCount();
	while ((GetTickCount() - dwStart) < 500);
/*
	CString strResult = SendCommand(_T("ATZ\r"), _T("OK\x0d\x0a"), 3000);
	if (m_bReceived) 
	{
		m_nState = ready;
	}
	else if (m_uInitRetry < 5) 
		PostMessage(WM_APP+1);
*/

	m_ctrlEdit.EnableWindow(TRUE);
	m_ctrlEdit.SetWindowText(_T(""));
	m_ctrlEdit.SetFocus();

	m_ctrlConnect.SetWindowText(_T("Disconnect"));

	CString str;
	str.Format(_T("Baud rate: %d"), br);
	m_ctrlEdit.SetWindowText(str.LockBuffer());
	str.UnlockBuffer();

}

void CTerminalDlg::OnDisconnect() 
{
	if (m_hPort != INVALID_HANDLE_VALUE)
	{
		CloseHandle(m_hPort);
		m_hPort = INVALID_HANDLE_VALUE;
	}

	m_ctrlEdit.EnableWindow(FALSE);
}

LRESULT CTerminalDlg::OnSendChar(WPARAM wp, LPARAM lp)
{
	SendChar((UINT)wp);
	return 1;
}

void CTerminalDlg::SendChar(UINT nChar)
{
	if (m_hPort == INVALID_HANDLE_VALUE)
		return;

	BYTE bByte = (BYTE)nChar;

	if (! DEBUGMODE)
	{
		DWORD dwBytesWritten = 0;
		if (! WriteFile(m_hPort,				// Port handle
						&bByte,					// Pointer to the data to write 
						1,						// Number of bytes to write
						&dwBytesWritten,		// Pointer to the number of bytes 
												// written
						NULL))					// Must be NULL for Windows CE
		{
			MessageBox(TEXT("Write Error"), TEXT("Terminal"), MB_OK | MB_ICONHAND);
			return;
		}
	}
	else
	{
		memcpy(&DebugData[DebugLen], &bByte, 1);
		DebugLen += 1;
	}
}

void CTerminalDlg::OnTimer(UINT nIDEvent) 
{
	if (m_hPort == INVALID_HANDLE_VALUE)
		return;

	BYTE  Bytes[256];
	DWORD dwBytesRead = 0;

	if (! DEBUGMODE)
	{
		if (! ReadFile(m_hPort,             // Port handle
					   Bytes,	            // Pointer to data to read
					   256,                 // Number of bytes to read
					   &dwBytesRead,		// Pointer to number of bytes
											// read
					   NULL))				// Must be NULL for Windows CE
		{
			MessageBox(TEXT("Write Error"), TEXT("Terminal"), MB_OK | MB_ICONHAND);
			return;
		}
	}
	else
	{
		memcpy(Bytes, DebugData, DebugLen);
		dwBytesRead = DebugLen;
		DebugLen = 0;
	}

	if (dwBytesRead > 0)
	{
		CString strRead = _T("");
		CString strText = _T("");
		m_ctrlEdit.GetWindowText(strText);
		
		for(int i=0; i<(int)dwBytesRead; i++)
		{
			strRead.Format(_T("%C"), Bytes[i]); // convert to Unicode
			strText += strRead;
		}

		m_ctrlEdit.SetWindowText(strText);
		int nLines = m_ctrlEdit.GetLineCount();
		int visible = m_ctrlEdit.GetFirstVisibleLine();
		int nScroll = nLines - visible - 4;
		if(nScroll < 0)
			nScroll = 0;
		m_ctrlEdit.LineScroll(nScroll);
	}

	CDialog::OnTimer(nIDEvent);
}

void CTerminalDlg::OnButtonSend() 
{
	if (m_hPort == INVALID_HANDLE_VALUE)
		return;

	UpdateData();

	const TCHAR* psz = LPCTSTR(m_strToSend);

	BYTE ar2send[256];

	for(int i=0; i< m_strToSend.GetLength(); i++)
		ar2send[i] = (BYTE)(*psz++);

	if(m_bAddCRLF)
	{
		ar2send[i++] = 13;
		ar2send[i++] = 10;
	}

	if (! DEBUGMODE)
	{
		DWORD dwBytesWritten = 0;
		if (! WriteFile(m_hPort,				// Port handle
						ar2send,					// Pointer to the data to write 
						i,						// Number of bytes to write
						&dwBytesWritten,		// Pointer to the number of bytes 
												// written
						NULL))					// Must be NULL for Windows CE
		{
			MessageBox(TEXT("Write Error"), TEXT("Terminal"), MB_OK | MB_ICONHAND);
			return;
		}
/*		else
		{
			TCHAR sz[12];
			_itow(dwBytesWritten, sz, 10);
			MessageBox(sz, TEXT("Bytes written"), MB_OK | MB_ICONINFORMATION);
		}*/
	}
}
